double inner_product (int N, double *vec1, double *vec2);
double pearson_coefficient (int N, double *vec1, double *vec2);


double simple_estimation (int N, int **bond);


int count_nodes (char *filename);
void read_edges (char *filename, int N, int **bond);
void from_bond_to_edges (int N, int **bond, int **edges);
int largest_connected_component (int N, int **bond, int **tmp_bond);



void init_vector (int N, double *vec);
double normalize_vector (int N, double *vec);
double estimate_error (int N, double *vec1, double *vec2);
double principal_nonbacktracking (int N, int **bond, double *eigenvector);
double single_iteration_nonback(int N, int **bond, double *vec, double *vec_tmp);
double single_iteration_adjacency (int N, int **bond, double *vec, double *vec_tmp);
double principal_adjacency (int N, int **bond, double *eigenvector);
///////////////////


void construct_non_backtracking_matrix (int N, int **bond, int **reference, int M, int **bond_non, int **ref_vec);
double principal_nonbacktracking_true (int N, int **bond, double *eigenvector);
void matrix_transpose (int N, int **bond, int **trasp_bond);
